Bug 800190 - Bug found in setroubleshoot-3.1.2-1.fc17 using gcc-with-cpychecker static analyzer
Bug found in setroubleshoot-3.1.2-1.fc17 using gcc-with-cpychecker static ana...
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: setroubleshoot (Show other bugs)
19
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Daniel Walsh
Fedora Extras Quality Assurance
http://fedorapeople.org/~dmalcolm/gcc...
:
Depends On:
Blocks: cpychecker
  Show dependency treegraph
 
Reported: 2012-03-05 17:37 EST by Dave Malcolm
Modified: 2014-01-02 16:16 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-01-02 16:16:49 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Dave Malcolm 2012-03-05 17:37:09 EST
Description of problem:
I've been writing an experimental static analysis tool to detect bugs commonly occurring within C Python extension modules:
  https://fedorahosted.org/gcc-python-plugin/
  http://gcc-python-plugin.readthedocs.org/en/latest/cpychecker.html
  http://fedoraproject.org/wiki/Features/StaticAnalysisOfPythonRefcounts

I ran the latest version of the tool (in git master; post 0.9) on
setroubleshoot-3.1.2-1.fc17.src.rpm, and it reports various errors.

You can see a list of errors here, triaged into categories (from most significant to least significant):
http://fedorapeople.org/~dmalcolm/gcc-python-plugin/2012-03-05/setroubleshoot-3.1.2-1.fc17/

I've manually reviewed the issues reported by the tool.

Within the category "Reference leaks" the 1 issue reported looks like a genuine leak of "list" in the early-exit case.

Within the category "Possible reference leaks" the 1 issue reported may or may not be a genuine bug, depending on whether sesearch returns a new or a borrowed reference (consider using Py_BuildValue("N" for the latter case).

Within the category "Returning (PyObject*)NULL without setting an exception" the 1 issue reported might or might not be a genuine bug; it's not clear without more context.

There may of course be other bugs in my checker tool.

Hope this is helpful; let me know if you need help reading the logs that the tool generates - I know that it could use some improvement.

Version-Release number of selected component (if applicable):
setroubleshoot-3.1.2-1.fc17
gcc-python-plugin post-0.9 git 11462291a66c8db693c8884cb84b795bb5988ffb running the checker in an *f16* chroot
Comment 1 Fedora End Of Life 2013-04-03 10:43:06 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 2 Daniel Walsh 2014-01-02 16:16:49 EST
Removed sesearch.c code from setroubleshoot, now using sepolicy.

Note You need to log in before you can comment on or make changes to this bug.